<?php
/**
* MyPhotoPlugin.class.php
* 
* Plugin zum Bloggen
* 
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

include_once("Simple_Blogging_Template.class.php");
require_once ("lib/messaging.inc.php");

class BloggingPlugin extends AbstractStudIPHomepagePlugin {

	var $user = NULL;
	var $permissions;
	var $req_user = NULL;
	var $permalink;
	var $messaging;

	function BloggingPlugin(){
		parent::AbstractStudIPHomepagePlugin();
		$this->setPluginIconName('edit_transparent.gif');
		$this->user = $this->getUser();
		$this->permissions = $this->user->getPermission();
		$this->messaging = new messaging;
	}
	
	function setPluginpath($newpath){
		parent::setPluginpath($newpath);
		$this->buildMenu();
	}

	function setRequestedUser($user) {
                parent::setRequestedUser($user);
		$u = new StudIPUser();
		$u = $this->getRequestedUser();
		$this->req_user = $u;
                //$u = $this->getRequestedUser();
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND visible=1",$this->req_user->getUserId());
                $this->setStatusShowOverviewPage(($db->num_rows() > 0 ? TRUE : FALSE));
		$this->permalink = $GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/blog.php?a=";
        }

	function getPluginname() {
                return "Blog";
        }
	
	function buildMenu(){
		$tab = new PluginNavigation();
		$tab->setDisplayname(_("Blog"));
		$this->setNavigation($tab); 
	}

	function createInfoBox ($imgLogo) {
                $info1 =  array ("icon" => "info.gif", "text" => _("Hier k&ouml;nnen Sie Ihren pers&ouml;nlichen Blog mit Inhalten f&uuml;llen."));
                $info2 =  array ("icon" => "vote-icon-visible.gif", "text" => _("Damit Ihre Beitr&auml;ge von anderen Benutzern gelesen werden k&ouml;nnen, muss die Sichtbarkeit aktiviert werden."));
                $infobox = array (array ("kategorie" => _("Information:"), "eintrag"   => array ($info1,$info2)));
                return print_infobox ($infobox, $imgLogo, YES);
        }

	function get_comment_count($entry_id) {
		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM blog_comments WHERE entry_id='%s'",$entry_id);
                return $db->num_rows();
	}

	function show() {
		global $PHP_SELF, $perm;

		$db = new DB_Seminar();
                $db2 = new DB_Seminar();
                $msg = "";

		if ($this->req_user->getUserId() == $this->user->getUserId() || $perm->have_perm("root")) {

			echo "<LINK REL=\"stylesheet\" HREF=\"".$GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath()."/style-blog.css\" TYPE=\"text/css\" />\n";

			//echo "<DIV STYLE=\"display:table\">\n";
                        //echo "<DIV STYLE=\"display:table-row\">\n";
                        //echo "<DIV STYLE=\"display:table-cell\">\n";
                        echo "<TABLE BORDER=\"0\"><TR><TD VALIGN=\"TOP\">\n";

			$open = trim($_REQUEST['open']);
                        $modus = trim($_REQUEST['modus']);

			$page_date = trim($_REQUEST['page_date']);
			$page_date = ($page_date == "" ? date("Y",time())."@".date("n",time()) : $page_date);

			if ($modus == "create_entry") {
				$id =  md5(uniqid(time()));
				$titel = _("Neuer Eintrag");
				$desc = _("Neuer Eintrag");
				$db->queryf("INSERT INTO blog_entries(entry_id, user_id, titel, description, mkdate) VALUES ('%s', '%s', '%s', '%s', UNIX_TIMESTAMP())", $id, $this->user->getUserId(), $titel, $desc);
				$open = $id;
				$msg = "msg"._("Eintrag angelegt.");
			}
			if ($modus == "save_entry" || $modus == "preview") {
                                $id = trim($_REQUEST['entry_id']);
                                $titel = trim($_REQUEST['titel']);
                                $description = trim($_REQUEST['description']);
                                $visible = (trim($_REQUEST['visible']) ? 1 : 0);
                                if (strlen(trim($titel)) > 0) {
                                        $db->queryf("UPDATE blog_entries SET titel='%s', description='%s', visible=%d, chdate=UNIX_TIMESTAMP() WHERE entry_id='%s' AND user_id='%s'",$titel,$description,$visible,$id,$this->user->getUserId());
                                        $msg = "msg"._("Eintrag gespeichert!");
                                }
                                $open = $id;
                        }
			if ($modus == "delete_entry") {
                                $id = trim($_REQUEST['entry_id']);
                                echo "<A NAME=\"anker\"></A>\n";
                                // echo "<DIV STYLE=\"width:700px; margin:25px; padding:5px; border-color:red; border-width:thin; border-style:solid\">\n";
                                echo "<DIV CLASS=\"warn-body\">\n";
                                echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">&nbsp;";
                                echo sprintf(_("Wollen Sie diesen Eintrag mit %d Kommentar(en) wirklich l&ouml;schen?"),$this->get_comment_count($id));
                                echo "<BR><A HREF=\"".PluginEngine::getLink($this,array("modus"=>"delete_entry_really","entry_id"=>$id),"show")."\">".makeButton("ja","img")."</A>&nbsp;\n";
                                echo "<A HREF=\"".PluginEngine::getLink($this,array("open"=>$id),"show")."\">".makeButton("nein","img")."</A>\n";
                                echo "</DIV>\n";
                        }
                        if ($modus == "delete_entry_really") {
                                $id = trim($_REQUEST['entry_id']);
                                $db->queryf("DELETE FROM blog_entries WHERE entry_id='%s' AND user_id='%s'",$id,$this->req_user->getUserId());
                                $db->queryf("DELETE FROM blog_comments WHERE entry_id='%s'",$id);
                                $msg = "msg"._("Eintrag wurde gel&ouml;scht!");
				if ($GLOBALS['auth']->auth["uid"] != $this->req_user->getUserId()) {
					$message = "Ein Blog-Eintrag wurde von der Administration geloescht!\n\n";
                                        $this->messaging->insert_message($message, get_username($this->req_user->getUserId()), "____%system%____", FALSE, FALSE, 1, FALSE, _("Blog-Eintrag geloescht"));
				}
                        }
			if ($modus == "delete_comment") {
				$comment_id = $_REQUEST['comment_id'];
				$db->queryf("SELECT c.* FROM blog_entries e, blog_comments c WHERE e.entry_id=c.entry_id AND c.comment_id='%s' AND e.user_id='%s'",$comment_id, $this->user->getUserId());
				// Ist es wirklich der eigene Blogeintrag, zu dem der Kommentar geloescht werden soll?
				if ($db->next_record() || $perm->have_perm("root")) {
					$db->queryf("DELETE FROM blog_comments WHERE comment_id='%s' AND entry_id='%s'", $comment_id, $open);
					$msg = "msg"._("Kommentar wurde gel&ouml;scht!");
					$modus = "view_comments";
					if ($GLOBALS['auth']->auth["uid"] != $this->req_user->getUserId()) {
						$message = "Ein Blog-Kommentar wurde von der Administration geloescht!\n\n";
                                        	$this->messaging->insert_message($message, get_username($this->req_user->getUserId()), "____%system%____", FALSE, FALSE, 1, FALSE, _("Blog-Kommentar geloescht"));
					}
				}
			}

			if ($msg) {
                                echo "<TABLE BORDER=\"0\">\n";
                                parse_msg($msg);
                                echo "</TABLE>\n";
                        }

			$tmp_page_date = explode("@", $page_date);
			$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND YEAR(FROM_UNIXTIME(mkdate))=%d AND MONTH(FROM_UNIXTIME(mkdate))=%d ORDER BY mkdate DESC",$this->req_user->getUserId(), $tmp_page_date[0], $tmp_page_date[1]);
			$db2->queryf("SELECT DISTINCT YEAR(FROM_UNIXTIME(mkdate)) jahr, MONTH(FROM_UNIXTIME(mkdate)) monat FROM blog_entries WHERE user_id='%s' ORDER BY 1 DESC, 2 DESC",$this->req_user->getUserId());
			echo "<CENTER><DIV CLASS=\"date-shortcut-body\">\n";
			while ($db2->next_record()) {
				$tmp_date_string = $db2->f("jahr")."-".$db2->f("monat")."-15";
				$tmp_date_string2 = date("F Y",strtotime($tmp_date_string));
				if ($page_date == $db2->f("jahr")."@".$db2->f("monat")) {
					echo "<B CLASS=\"date-shortcut\" STYLE=\"font-size:smaller; color:red\">".$tmp_date_string2."</B>\n";
				} else {
					echo "<A HREF=\"".PluginEngine::getLink($this,array("page_date"=>$db2->f("jahr")."@".$db2->f("monat")),"show")."#anker\" CLASS=\"date-shortcut\" STYLE=\"font-size:x-small\">".$tmp_date_string2."</A>\n";
				}
			}
			echo "</DIV></CENTER>\n";

			echo "<BLOCKQUOTE STYLE=\"font-size:smaller\">"._("Neuen Eintrag erstellen")."\n";
                        echo "<FORM NAME=\"new_item\" ACTION=\"".PluginEngine::getLink($this,array(),"show")."\" METHOD=\"POST\">\n";
                        echo "<INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"create_entry\">\n";
                        echo "<INPUT TYPE=\"image\" ".makeButton("anlegen","src").">\n";
                        echo "</FORM></BLOCKQUOTE>\n";

			//$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' ORDER BY mkdate DESC",$this->req_user->getUserId());
			while ($db->next_record()) {
				$link = PluginEngine::getLink($this,array(),"show");
				$icon = "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."images/news2.gif\" ALT=\"Blogentry\">";
				$tmp_titel=htmlReady(mila($db->f("titel")));
				$zusatz = ($db->f("visible") == 1 ? "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/vote-icon-visible.gif\" ALT=\""._("sichtbar")."\" TITLE=\""._("sichtbar")."\">&nbsp;" : "").date("d.m.Y H:i",$db->f("mkdate"));
				$titel = "<A HREF=\"".$link."&open=".($open==$db->f("entry_id")?"":$db->f("entry_id")."&page_date=$page_date#anker")."\"><FONT SIZE=\"-1\">".$tmp_titel."</FONT></A>";
				echo "             <TABLE BORDER=\"0\" WIDTH=\"100%\" CELLPADDING=\"0\" CELLSPACING=\"0\">\n";
                                echo "               <TR>\n";
                                printhead ("100%", 0, $link, ($open==$db->f("entry_id")?"open":"close"), FALSE, $icon, $titel, $zusatz, time());
                                echo "               </TR>\n";
                                echo "             </TABLE>\n";
                                if ($open == $db->f("entry_id")) {
					echo "<A NAME=\"anker\"></A>\n";
					echo "<CENTER>\n";
					echo "<FORM NAME=\"f".$db->f("entry_id")."\" ACTION=\"".PluginEngine::getLink($this,array("page_date"=>$page_date),"show")."\" METHOD=\"POST\">\n";
                		        echo "<DIV CLASS=\"steel1 editor-body\">\n";
                        		echo "<INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"save_entry\">\n";
		                        echo "<INPUT TYPE=\"hidden\" NAME=\"entry_id\" VALUE=\"".$db->f("entry_id")."\">\n";
                		        echo "<B STYLE=\"font-size:smaller\">"._("Titel").":</B><BR>\n";
		                        echo "<INPUT TYPE=\"text\" NAME=\"titel\" STYLE=\"width:600px\" VALUE=\"".htmlReady($db->f("titel"))."\">\n";
                		        echo "<INPUT TYPE=\"checkbox\" NAME=\"visible\" VALUE=\"1\" ".($db->f("visible")=="1" ? "CHECKED" : "")."><FONT STYLE=\"font-size:smaller\">"._("sichtbar")."</FONT>\n";
		                        echo "<B STYLE=\"font-size:smaller\">"._("Inhalt").":</B><BR>\n";
                		        echo "<B STYLE=\"font-size:x-small; color:gray\">"._("Hier kann die Stud.IP-Formatierung benutzt werden!")."</B><BR>\n";
		                        echo "<TEXTAREA NAME=\"description\" STYLE=\"width:695px; height:300px\">".htmlReady($db->f("description"))."</TEXTAREA><BR>\n";
                		        echo "<INPUT TYPE=\"image\" ".makeButton("speichern","src").">\n";
		                        echo "<INPUT TYPE=\"image\" onClick=\"document.f".$db->f("entry_id").".modus.value='delete_entry';\" ".makeButton("loeschen","src").">\n";
		                        echo "<INPUT TYPE=\"image\" onClick=\"document.f".$db->f("entry_id").".modus.value='preview';\" ".makeButton("vorschau","src").">\n";
					// echo "<B STYLE=\"font-size:x-small; color:gray\">Permalink: ".$PHP_SELF."?username=".get_username($this->req_user->getUserId())."&permlink=".$db->f("permanent_id")."</B>\n";
					echo "<BR><B STYLE=\"font-size:x-small; color:gray\">Permalink: ".$this->permalink.$db->f("permanent_id")."</B>\n";
                		        echo "</DIV>\n";
		                        echo "</FORM>\n";
					echo "</CENTER>\n";

					if ($modus == "preview") {
						$s = new Simple_Blogging_Template();
						$s->set_absolute_plugin_uri($GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath());
						$s->show_template($this->req_user->getUserId(), $this->permalink, $db->f("permanent_id"));
					}
				
					$db2->queryf("SELECT * FROM blog_comments WHERE entry_id='%s'",$db->f("entry_id"));
		                        $count_comments = $db2->num_rows();

					if ($count_comments > 0)
						echo "<CENTER><DIV CLASS=\"comment-link\"><A HREF=\"".PluginEngine::getLink($this,array("open"=>$db->f("entry_id")),"show").($modus != "view_comments" ? "&modus=view_comments" : "")."&page_date=$page_date#anker_comments\">"._("Kommentare").($count_comments > 0 ? " ($count_comments)" : "")."</A></DIV></CENTER>\n";
					if ($modus == "view_comments") {
						$db2->queryf("SELECT * FROM blog_comments WHERE entry_id='%s'ORDER BY mkdate DESC",$db->f("entry_id"));
						echo "<CENTER>\n";
        		                        while ($db2->next_record()) {
                	        	                echo "<DIV CLASS=\"comment-body\">\n";
                        	                	echo "<B CLASS=\"comment-author\">".date("d.m.Y H:i",$db2->f("mkdate"))."&nbsp;<A HREF=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."about.php?username=".get_username($db2->f("user_id"))."\">".get_fullname($db2->f("user_id"))."</A></B><BR>\n";
        	                	                echo "<P CLASS=\"comment\">".htmlReady($db2->f("content"))."</P>\n";
							echo "<A HREF=\"".PluginEngine::getLink($this,array("open"=>$db->f("entry_id"),"comment_id"=>$db2->f("comment_id")),"show")."&page_date=$page_date&modus=delete_comment#anker_comments\"><IMG ".makeButton("loeschen","src")." BORDER=\"0\"></A>\n";
                	                	        echo "</DIV>\n";
                        	        	}
						echo "</CENTER>\n";
					}
				}
			}

			echo "</TD><TD>\n";
                        echo "<TD WIDTH=\"2%\" VALIGN=\"TOP\">\n";
                        //echo "</DIV>\n";
                        //echo "<DIV STYLE=\"display:talbe-cell\">\n";
                        echo $this->createInfoBox("sms3.jpg");
                        //echo "</DIV>\n";
                        //echo "</DIV>\n";
                        //echo "</DIV>\n";

                        echo "</TD></TR></TABLE>\n";
		} else
			echo _("Zugriff verweigert!");
	}

	// function showAdministrationPage() {
	function actionShowAdministrationPage() {
		$this->show();
	}

	function showOverview() {
		$s = new Simple_Blogging_Template();
		$s->set_absolute_plugin_uri($GLOBALS['ABSOLUTE_URI_STUDIP'].$this->getPluginpath());
	
		echo "<DIV CLASS=\"big-white-div\">\n";
		$s->show_template($this->req_user->getUserId(), $this->permalink);
		echo "</DIV>\n";
		/*
		global $PHP_SELF;
		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$c_open = trim($_REQUEST['c_open']);
		$modus = trim($_REQUEST['modus']);
		$page = trim($_REQUEST['page']);
		$page = ($page == "" ? 1 : $page);
		$permlink = trim($_REQUEST['x']);

		if ($modus == "add_comment") {
			$id =  md5(uniqid(time()));
			$content = trim($_REQUEST['content']);
			if (strlen($content) > 0 && strlen($c_open) > 0) {
				$db->queryf("INSERT INTO blog_comments (comment_id, entry_id, user_id, mkdate, content) VALUES ('%s','%s','%s',UNIX_TIMESTAMP(),'%s')",$id,$c_open,$this->user->getUserId(),$content);
			}
		}

		echo "<A NAME=\"anker\">\n";

		$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND visible=1 %s ORDER BY mkdate DESC",$this->req_user->getUserId(),(!is_nan($permlink) && $permlink != "" ? " AND perm_link=$permlink" : ""));
		$page_count = ceil($db->num_rows() / 10);
		if ($page_count > 1) {
			echo "<CENTER>\n";
			echo "<B STYLE=\"font-size:x-small\">Seite&nbsp;</B>\n";
			for ($i=1; $i<=$page_count; $i++) {
				if ($page == $i)
					echo "<B STYLE=\"font-size:smaller; color:red\">$i</B>\n";
				else
					echo "<A HREF=\"$PHP_SELF?username=".get_username($this->req_user->getUserId())."&page=$i#anker\" STYLE=\"font-size:x-small\">$i</A>\n";
			}
			echo "</CENTER>\n";
			echo "<BR>\n";
		}
		$tmp_counter = 0;
		while ($db->next_record()) {
			$tmp_counter++;
			if ($tmp_counter < ($page-1)*10)
				continue;
			if ($tmp_counter > $page * 10)
				exit;
			echo "<CENTER>\n";
			//echo "<TABLE BORDER=\"0\" WIDTH=\"100%\"><TR><TD ALIGN=\"center\">\n";
			echo "<DIV STYLE=\"display:table; align:left; width:600px; margin:5px; padding:5px; border-color:gray; border-width:thin; border-style:dashed; background-color:#FFFFFF\">\n";
			echo "<B>".htmlReady($db->f("titel"))."</B><BR>\n";
			echo "<B STYLE=\"font-size:x-small; color:gray\">".date("d.m.Y H:i", $db->f("mkdate"))."</B>\n";
			echo "<P STYLE=\"font-size:smaller\">".formatReady($db->f("description"))."</P>\n";
			echo "<CENTER><P STYLE=\"font-size:smaller\"><A HREF=\"$PHP_SELF?c_open=".$db->f("entry_id")."&modus=view_comments&page=$page#anker_comments\">Kommentare</A></P></CENTER>\n";
			if ($c_open == $db->f("entry_id")) {
				echo "<A NAME=\"anker_comments\">\n";
				$db2->queryf("SELECT * FROM blog_comments ORDER BY mkdate DESC");
				while ($db2->next_record()) {
					echo "<DIV STYLE=\"width:400px; margin:5px; padding:5px; border-color:gray; border-width:thin; border-style:dotted\">\n";
					echo "<B STYLE=\"font-size:x-small\">".date("d.m.Y H:i",$db2->f("mkdate"))."&nbsp;<A HREF=\"about.php?username=".get_username($db2->f("user_id"))."\">".get_fullname($db2->f("user_id"))."</A></B><BR>\n";
					echo "<P STYLE=\"font-size:smaller\">".htmlReady($db2->f("content"))."</P>\n";
					echo "</DIV>\n";
				}
				echo "<FORM NAME=\"add_comment\" ACTION=\"$PHP_SELF?username=".get_username($this->req_user->getUserId())."&page=$page#anker_comments\" METHOD=\"POST\">\n";
				echo "<INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"add_comment\">\n";
				echo "<INPUT TYPE=\"hidden\" NAME=\"c_open\" VALUE=\"".$db->f("entry_id")."\">\n";
				echo "<TEXTAREA NAME=\"content\" STYLE=\"width:300px; height:50px\" wrap=virtual></TEXTAREA>\n";
				echo "<BR><INPUT TYPE=\"image\" ".makeButton("absenden","src").">\n";
				echo "</FORM>\n";
			}
			// echo "<B STYLE=\"font-size:x-small; color:gray\">Permalink: ".$PHP_SELF."?username=".get_username($this->req_user->getUserId())."&permlink=".$db->f("permanent_id")."</B>\n";
			echo "<B STYLE=\"font-size:x-small; color:gray\">Permalink: ".$this->permalink."?x=".$db->f("permanent_id")."</B>\n";
			echo "</DIV>\n";
			//echo "</TD></TR></TABLE>\n";
			echo "</CENTER>\n";
		}
		*/
	}

}

?>
