<?php

/**
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

class RSSProducer {
	
	function RSSProducer() {

	}

	function create_rss_stream($user_id) {
		$RssTimeFmt = '%Y-%m-%dT%H:%MZ';
	        $last_changed = 0;

		$studip_perm_blog_url = $GLOBALS['ABSOLUTE_URI_STUDIP'] . "plugins/packages/ZMML/BloggingPlugin/blog.php?a=";
		$studip_url = $GLOBALS['ABSOLUTE_URI_STUDIP'] . "about.php?again=yes&#38;username=".get_username($user_id);
		$title = get_fullname($user_id) . ' (Stud.IP - ' . $GLOBALS['UNI_NAME_CLEAN'] . ')';
		$RssChannelDesc = _("Persnlicher Blog von") . ' ' . $title;
		
		$title = htmlspecialchars($title);
	        $RssChannelDesc = htmlspecialchars($RssChannelDesc);

		$db = new DB_Seminar();
		$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND visible=1 ORDER BY mkdate DESC",$user_id);
		while ($db->next_record()) {
       		        $items .= "<item>".
                	"<title><![CDATA[".utf8_encode(date("d. F Y", $db->f("mkdate"))." @ ".date("H:i",$db->f("mkdate"))." ".$db->f("titel"))."]]></title>".
	                "<link>".utf8_encode($studip_perm_blog_url . $db->f("permanent_id"))."</link>";
        	        $items .= "<description><![CDATA[".utf8_encode(formatready($db->f("description"),1,1))."]]></description>".
                	"<dc:contributor><![CDATA[".utf8_encode(htmlready(get_fullname($db->f("user_id"))))."]]></dc:contributor>".
	                "<dc:date>".gmstrftime($RssTimeFmt,($db->f("mkdate") > $db->f("chdate") ? $db->f("mkdate") : $db->f("chdate")))."</dc:date>".
        	        "<pubDate>".date("r",($db->f("mkdate") > $db->f("chdate") ? $db->f("mkdate") : $db->f("chdate")))."</pubDate>".
                	"</item>\n";
	                if ($last_changed < $db->f("chdate")) $last_changed = $db->f("chdate");
        	}
	        header("Content-type: text/xml; charset=utf-8");
        	echo "<?xml version=\"1.0\"?>
	        <rss version=\"2.0\" xmlns:dc=\"http://purl.org/dc/elements/1.1/\">
        	<channel>
	        <title><![CDATA[".utf8_encode($title)."]]></title>
        	<link>$studip_url</link>
	        <image>
        	<url>http://www.studip.de/images/studip_logo.gif</url>
	        <title><![CDATA[".utf8_encode($title)."]]></title>
        	<link>$studip_url</link>
	        </image>
        	<description><![CDATA[".utf8_encode($RssChannelDesc)."]]></description>
	        <lastBuildDate>".date("r",$last_changed)."</lastBuildDate>
        	<generator>". utf8_encode('Stud.IP - ' . htmlspecialchars($GLOBALS['SOFTWARE_VERSION'])) . "</generator>";
	        echo chr(10).$items;
		echo "</channel>\n</rss>";
	        return true;
	}

}

?>
