<?php
/**
* @author               Jan Kulmann <jankul@zmml.uni-bremen.de>
*/

// +---------------------------------------------------------------------------+
// This file is NOT part of Stud.IP
// Copyright (C) 2007 Jan Kulmann <jankul@zmml.uni-bremen.de>
// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once ("lib/messaging.inc.php");

class Simple_Blogging_Template {

	var $absolute_plugin_uri;

	function Simple_Blogging_Template() {

	}

	function set_absolute_plugin_uri($s) {
		$this->absolute_plugin_uri = $s;
	}

	function get_trackback_uris($id, $user_id, $permalink) {
	        $ret = array();
        	if ($id && $user_id && $permalink) {
                	$db = new DB_Seminar();
	                $uri = $permalink.$id;
        	        $db->queryf("SELECT * FROM blog_entries WHERE user_id!='%s' AND visible=1 AND description LIKE '%s'",$user_id,"%".$uri."%");
	                while ($db->next_record()) {
        	                array_push($ret,array($permalink.$db->f("permanent_id"),$db->f("titel"),get_fullname($db->f("user_id")),get_username($db->f("user_id"))));
                	}
	        }
        	return $ret;
	}

	function show_template($req_user_id, $permalink, $preview_id=NULL) {
		global $PHP_SELF, $auth;

		echo "<LINK REL=\"stylesheet\" HREF=\"".$this->absolute_plugin_uri."/style-blog.css\" TYPE=\"text/css\" />\n";

		if (!$preview_id)
			echo "<CENTER><DIV CLASS=\"headline\">~&nbsp;".sprintf(_("Pers&ouml;nlicher Blog von")." %s",get_fullname($req_user_id))."&nbsp;~</DIV></CENTER>\n";

		$db = new DB_Seminar();
		$db2 = new DB_Seminar();
		$c_open = trim($_REQUEST['c_open']);
		$t_open = trim($_REQUEST['t_open']);
		$modus = trim($_REQUEST['modus']);
		$page = trim($_REQUEST['page']);
		$page = ($page == "" ? 1 : $page);
		$page_date = trim($_REQUEST['page_date']);
		$page_date = ($page_date == "" ? date("Y",time())."@".date("n",time()) : $page_date);
		$permlink = trim($_REQUEST['a']);
		if ($preview_id) $permlink = $preview_id;
		if ($permlink != "")
			if (is_nan($permlink)) $permlink = "";

		if ($modus == "add_comment") {
			$id =  md5(uniqid(time()));
			$content = trim($_REQUEST['content']);
			$db2->queryf("SELECT visible, permanent_id FROM blog_entries WHERE entry_id='%s'",$c_open);
			$db2->next_record();
			if (strlen($content) > 0 && strlen($c_open) > 0 && $db2->f("visible") == 1) {
				$db->queryf("INSERT INTO blog_comments (comment_id, entry_id, user_id, mkdate, content) VALUES ('%s','%s','%s',UNIX_TIMESTAMP(),'%s')",$id,$c_open,$auth->auth["uid"],$content);
				if ($auth->auth["uid"] != $req_user_id) {
					$message = _("Du hast einen neuen Kommentar in deinem Blog!")."\n\n";
					$message .= $permalink.$db2->f("permanent_id");
					$messaging=new messaging;
					$messaging->insert_message($message, get_username($req_user_id), $auth->auth["uid"], FALSE, FALSE, 1, FALSE, _("Neuer Blog-Kommentar"));
				}
			}
		}
		if ($modus == "send_report") {
			echo "<A NAME=\"report_anker\"></A>\n";
			echo "<CENTER><DIV CLASS=\"warn-body\">\n";
                        echo "<IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/ausruf.gif\">&nbsp;";
                        echo _("Wenn Sie diesen Beitrag der Administration melden wollen, geben Sie bitte einen erkl&auml;renden Text zur Begr&uuml;ndung an!")."\n";
			echo "<FORM NAME=\"report_entry\" ACTION=\"$PHP_SELF?username=".get_username($req_user_id)."&page_date=$page_date&page=$page".($permlink != "" ? "&a=$permlink" : "")."&c_open=$c_open\" METHOD=\"POST\">\n";
			echo "<INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"\">\n";
			echo "<BR><TEXTAREA NAME=\"report\" STYLE=\"width:400px; height:100px;\"></TEXTAREA><BR><BR>\n";
			echo "<INPUT TYPE=\"image\" ".makeButton("absenden","src")." onClick=\"document.report_entry.modus.value='send_report_really'; document.report_entry.submit();\">\n";
			echo "<INPUT TYPE=\"image\" ".makeButton("abbrechen","src").">\n";
			echo "</FORM>\n";
                        echo "</DIV></CENTER>\n";
			$c_open = NULL;
		}
		if ($modus == "send_report_really") {
			$username = trim($_REQUEST['username']);
			$report = trim($_REQUEST['report']);
			if (strlen($username) > 0) {
				$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND entry_id='%s'",get_userid($username), $c_open);
				if ($db->next_record()) {
					$db2->queryf("SELECT Vorname, Nachname, Email FROM auth_user_md5 WHERE user_id='%s'",$auth->auth['uid']);
					$db2->next_record();
					$subject = _("Meldung eines Blog-Eintrages");
					$message = sprintf(_("Ein Blogeintrag von %s (%s) wurde von %s (%s) beanstandet:\n\n"),get_fullname($req_user_id), get_username($req_user_id), get_fullname($auth->auth['uid']), get_username($auth->auth['uid']));
					$message .= "Begrndung: ".($report ? htmlReady($report) : "Keine Begrndung angegeben!")."\n\n";
					$message .= "Titel: ".htmlReady($db->f("titel"))." (".date("d.m.Y H:i",$db->f("mkdate"))." / ".date("d.m.Y H:i",$db->f("chdate")).")\n\n";
					$message .= "Inhalt:\n".$db->f("description");
					//$messaging=new messaging;
					//$messaging->insert_message($message, "kulmann_root", $auth->auth["uid"], FALSE, FALSE, 1, FALSE, _("Meldung eines Blog-Eintrages"));
					$header .= "From: " . $db2->f("Vorname")." ".$db2->f("Nachname")." <".$db2->f("Email").">\r\n";
					$header .= "Reply-To: " . $db2->f("Vorname")." ".$db2->f("Nachname")." <".$db2->f("Email").">\r\n";
					@mail($GLOBALS['UNI_CONTACT'], $subject, $message, $header);
					//@mail("jankul@zmml.uni-bremen.de", $subject, $message, $header);
				}
			}
			$c_open = NULL;
		}

		echo "<A NAME=\"anker\"></A>\n";
		if ($permlink != "" && !$preview_id) 
			$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND visible=1 AND permanent_id=%d ORDER BY mkdate DESC",$req_user_id, $permlink);
		else if ($permlink == "" && !$preview_id) {
			echo "<DIV STYLE=\"text-align:right\"><A HREF=\"".$this->absolute_plugin_uri."/blog.php?modus=rss&username=".get_username($req_user_id)."\"><IMG SRC=\"".$GLOBALS['ASSETS_URL']."/images/rss.gif\" BORDER=\"0\" ALT=\""._("RSS-Feed")."\" TITLE=\""._("RSS-Feed")."\"></A></DIV>\n";

			$tmp_page_date = explode("@", $page_date);
			$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND visible=1 AND YEAR(FROM_UNIXTIME(mkdate))=%d AND MONTH(FROM_UNIXTIME(mkdate))=%d ORDER BY mkdate DESC",$req_user_id, $tmp_page_date[0], $tmp_page_date[1]);

			$db2->queryf("SELECT DISTINCT YEAR(FROM_UNIXTIME(mkdate)) jahr, MONTH(FROM_UNIXTIME(mkdate)) monat FROM blog_entries WHERE user_id='%s' AND visible=1 ORDER BY 1 DESC, 2 DESC",$req_user_id);
			echo "<CENTER><DIV CLASS=\"date-shortcut-body\">\n";
			while ($db2->next_record()) {
				$tmp_date_string = $db2->f("jahr")."-".$db2->f("monat")."-15";
				$tmp_date_string2 = date("F Y",strtotime($tmp_date_string));
				if ($page_date == $db2->f("jahr")."@".$db2->f("monat")) {
					echo "<B CLASS=\"date-shortcut\" STYLE=\"font-size:smaller; color:red\">".$tmp_date_string2."</B>\n";
				} else {
					echo "<A HREF=\"$PHP_SELF?username=".get_username($req_user_id)."&page_date=".$db2->f("jahr")."@".$db2->f("monat")."#anker\" CLASS=\"date-shortcut\" STYLE=\"font-size:x-small\">".$tmp_date_string2."</A>\n";
				}
			}
			echo "</DIV></CENTER>\n";

			$page_count = ceil($db->num_rows() / 10);
			if ($page_count > 1) {
				echo "<CENTER>\n";
				echo "<B STYLE=\"font-size:x-small\">"._("Seite")."&nbsp;</B>\n";
				for ($i=1; $i<=$page_count; $i++) {
					if ($page == $i)
						echo "<B STYLE=\"font-size:smaller; color:red\">$i</B>\n";
					else
						echo "<A HREF=\"$PHP_SELF?username=".get_username($req_user_id)."&page=$i#anker\" STYLE=\"font-size:x-small\">$i</A>\n";
				}
				echo "</CENTER>\n";
				echo "<BR>\n";
			}
			$tmp_counter = 0;
		} else if ($preview_id) {
			$db->queryf("SELECT * FROM blog_entries WHERE user_id='%s' AND permanent_id=%d ORDER BY mkdate DESC",$req_user_id, $preview_id);
		}

		while ($db->next_record()) {
			if ($permlink == "") {
				$tmp_counter++;
				if ($tmp_counter < ($page-1)*10)
					continue;
				if ($tmp_counter > $page * 10)
					exit;
			}

			$db2->queryf("SELECT * FROM blog_comments WHERE entry_id='%s'",$db->f("entry_id"));
			$count_comments = $db2->num_rows();

			echo "<CENTER>\n";
			echo "<DIV CLASS=\"blogbody\">\n";
			echo "<H3 CLASS=\"date\">".date("d. F Y", $db->f("mkdate"))." @ ".date("H:i",$db->f("mkdate"))."</H3>\n";
			echo "<H3 CLASS=\"title\">".htmlReady($db->f("titel"))."</H3>\n";
			//echo "<P>".formatReady($db->f("description"), TRUE, TRUE)."</P>\n";
			//echo formatReady($db->f("description"), TRUE, TRUE)."\n";
			if (strlen($db->f("description")) > 300 && !$permlink) {
				$content = substr($db->f("description"), 0,300)."... [["._("mehr")."]".$permalink.$db->f("permanent_id")."]";
			} else
				$content = $db->f("description");
			echo formatReady($content, TRUE, TRUE)."\n";
			if ($db->f("chdate"))
				echo "<DIV CLASS=\"posted\"><B>"._("zuletzt ge&auml;ndert").": ".date("d.m.Y H:i",$db->f("chdate"))."</B></DIV>\n";
			if (!$preview_id) {
				$tb_uris = $this->get_trackback_uris($db->f("permanent_id"), $db->f("user_id"), $permalink);

				echo "<DIV CLASS=\"mini-link-collection\">\n";
				// Trackback
				if (count($tb_uris) > 0)
				echo "<DIV CLASS=\"trackback-link\"><A HREF=\"$PHP_SELF?username=".get_username($req_user_id)."&page_date=$page_date&page=$page".($permlink != "" ? "&a=".$db->f("permanent_id") : "").($t_open ? "#anker" : "&t_open=".$db->f("entry_id")."#anker_trackback_uris")."\">"._("Trackback")." (".count($tb_uris).")</A></DIV>\n";
				// Comments
				echo "<DIV CLASS=\"comment-link\"><A HREF=\"$PHP_SELF?username=".get_username($req_user_id)."&page_date=$page_date&page=$page".($permlink != "" ? "&a=".$db->f("permanent_id") : "").($c_open ? "#anker" : "&c_open=".$db->f("entry_id")."#anker_comments")."\">"._("Kommentare").($count_comments > 0 ? " ($count_comments)" : "")."</A></DIV>\n";
				// Reporting
				echo "<DIV CLASS=\"entry-reporting\"><A HREF=\"$PHP_SELF?username=".get_username($req_user_id)."&page_date=$page_date&page=$page".($permlink != "" ? "&a=".$db->f("permanent_id") : "")."&c_open=".$db->f("entry_id")."&modus=send_report#report_anker\">Beitrag melden</A></DIV>\n";
				echo "</DIV>\n";

				if (count($tb_uris) > 0) {
					if ($t_open == $db->f("entry_id")) {
						echo "<A NAME=\"anker_trackback_uris\"></A>\n";
						echo "<UL CLASS=\"list-item-intern\">\n";
						foreach ($tb_uris as $tb) {
							echo "<LI><A HREF=\"".$tb[0]."\" TARGET=\"trackback\">".htmlReady($tb[1])."</A> [<A HREF=\"about.php?username=".$tb[3]."\">".$tb[2]."</A>]\n";
						}
						echo "</UL>\n";
					}
				}
				if ($c_open == $db->f("entry_id")) {
					echo "<A NAME=\"anker_comments\"></A>\n";
					$db2->queryf("SELECT * FROM blog_comments WHERE entry_id='%s'ORDER BY mkdate DESC",$db->f("entry_id"));
					echo "<CENTER>\n";
					while ($db2->next_record()) {
						echo "<DIV CLASS=\"comment-body\">\n";
						echo "<B CLASS=\"comment-author\">".date("d.m.Y H:i",$db2->f("mkdate"))."&nbsp;<A HREF=\"".$GLOBALS['ABSOLUTE_URI_STUDIP']."about.php?username=".get_username($db2->f("user_id"))."\">".get_fullname($db2->f("user_id"))."</A></B><BR>\n";
						echo "<P CLASS=\"comment\">".htmlReady($db2->f("content"))."</P>\n";
						echo "</DIV>\n";
					}
					echo "<FORM NAME=\"add_comment\" ACTION=\"$PHP_SELF?username=".get_username($req_user_id)."&cmd=showOverview&username=".get_username($req_user_id)."&page=$page".($permlink != "" ? "&a=".$db->f("permanent_id") : "")."&page_date=$page_date#anker_comments\" METHOD=\"POST\">\n";
					echo "<INPUT TYPE=\"hidden\" NAME=\"modus\" VALUE=\"add_comment\">\n";
					echo "<INPUT TYPE=\"hidden\" NAME=\"c_open\" VALUE=\"".$db->f("entry_id")."\">\n";
					echo "<TEXTAREA NAME=\"content\" STYLE=\"width:413px; height:70px\" wrap=virtual></TEXTAREA>\n";
					echo "<BR><INPUT TYPE=\"image\" ".makeButton("absenden","src").">\n";
					echo "</FORM>\n";
					echo "</CENTER>\n";
				}
			}
			// echo "<B CLASS=\"permalink\">Permalink: <A HREF=\"".$permalink.$db->f("permanent_id")."\" TARGET=\"blog_entry\">".$permalink.$db->f("permanent_id")."</A></B>\n";
			echo "<B CLASS=\"permalink\">Permalink: ".$permalink.$db->f("permanent_id")."</B>\n";
			echo "</DIV>\n";
			echo "</CENTER>\n";
		}
	}
}
?>
